## Install

`pip install .`

## Crawling the network by hand

```
# Crawl the network starting from open.audio
funkwhale-network crawl open.audio
# Crawl the netowork starting from pods listed at https://network.funkwhale.audio
funkwhale-network crawl --use-public
# Limit crawl to 5 max successive passes
funkwhale-network crawl --use-public --passes 5
# Show detailed results per domain
funkwhale-network crawl --use-public --detail ""
# Show detailed results per domain with specific columns, ordering by a given column
funkwhale-network crawl --use-public --detail "Domain,Listenings,Active users (30d)" --sort="Listenings"
```

## Running tests

Ensure you have a postgres server running (via docker: `docker run --rm --name=pg -p 5432:5432 -e POSTGRES_PASSWORD=postgres -e POSTGRES_DB=funkwhale_network_test timescale/timescaledb:latest-pg11`)

`export DB_DSN="user=postgres password=postgres dbname=funkwhale_network_test host=localhost"`
