from aiohttp import web

from funkwhale_network import db, settings


@web.middleware
async def conn_middleware(request, handler):
    if request.app["pool"] is None:
        request.app["pool"] = await db.get_pool(settings.DB_DSN)

    async with request.app["pool"].acquire() as conn:
        request["conn"] = conn
        return await handler(request)
