import environ
from arq.connections import RedisSettings

env = environ.Env()
env_file = env("ENV_FILE", default=None)
if env_file:
    path = environ.Path(env_file)
    try:
        path.file("")
    except FileNotFoundError:
        raise ValueError(f"Env file {path} does not exist")
    env.read_env(env_file)

DB_DSN = env(
    "DB_DSN", default="user=postgres password=postgres dbname=funkwhale_network host=db"
)
CRAWLER_USER_AGENT = env(
    "CRAWLER_USER_AGEN", default="funkwhale/network https://network.funkwhale.audio"
)
CRAWLER_TIMEOUT = env.int("CRAWLER_TIMEOUT", default=5)

# from funkwhale_network import middlewares


# MIDDLEWARES = [middlewares.conn_middleware]
PORT = env.int("APP_PORT", default=8000)
GF_SERVER_ROOT_URL = env("GF_SERVER_ROOT_URL", default="/dashboards/")
REDIS_CONFIG = RedisSettings(
    host=env("REDIS_HOST", default="localhost"),
    port=env.int("REDIS_PORT", default=6379),
    database=env.int("REDIS_DB", default=0),
    password=env("REDIS_PASSWORD", default=None),
)
